#include <windows.h>

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <fstream.h>

#include <iostream>
#include <string>
#include <fstream>


#define WINIO


#ifdef WINIO
  #include "winio.h"
#endif


const int delay = 0;


#define BASE 0x378      // lpt portin osoite
#define DATA BASE
#define CONTROL BASE + 2


#define PIN1HI  0; // 0000 inverted
#define PIN1LO  1; // 0001 inverted

#define PIN14HI 0; // 0000 inverted
#define PIN14LO 2; // 0010 inverted

#define PIN16HI 4; // 0100
#define PIN16LO 0; // 0000

#define PIN17HI 0; // 0000 inverted
#define PIN17LO 8; // 1000 inverted


#define DISPLAY_ON         0x3f  //0011 1111
#define DISPLAY_OFF        0x3e  //0011 1110
#define DISPLAY_STARTLINE  0xc0  //1100 0000
#define DISPLAY_PAGE_SET   0xb8  //1011 1000
#define DISPLAY_COLUMN_SET 0x40  //0100 0000



int ENABLE_HI;
int ENABLE_LO;
int CS1_HI;
int CS1_LO;
int CS2_HI;
int CS2_LO;
int RS_HI;
int RS_LO;

unsigned char CS1;
unsigned char CS2;
unsigned char CurrentColumn;


  int en_pin=1;
  int cs1_pin=14;
  int cs2_pin=16;
  int rs_pin=17;


int  en = en_pin;
int  cs1 = cs1_pin;
int  cs2 = cs2_pin;
int  rs = rs_pin;


void SetPins(void)
{
  switch (en)
  {
    case 1:  ENABLE_HI = PIN1HI; break;
    case 14: ENABLE_HI = PIN14HI; break;
    case 16: ENABLE_HI = PIN16HI; break;
    case 17: ENABLE_HI = PIN17HI; break;
  }

  switch (en)
  {
    case 1:  ENABLE_LO = PIN1LO; break;
    case 14: ENABLE_LO = PIN14LO; break;
    case 16: ENABLE_LO = PIN16LO; break;
    case 17: ENABLE_LO = PIN17LO; break;
  }

  switch (cs1)
  {
    case 1:  CS1_HI = PIN1HI; break;
    case 14: CS1_HI = PIN14HI; break;
    case 16: CS1_HI = PIN16HI; break;
    case 17: CS1_HI = PIN17HI; break;
  }

  switch (cs1)
  {
    case 1:  CS1_LO = PIN1LO; break;
    case 14: CS1_LO = PIN14LO; break;
    case 16: CS1_LO = PIN16LO; break;
    case 17: CS1_LO = PIN17LO; break;
  }

  switch (cs2)
  {
    case 1:  CS2_HI = PIN1HI; break;
    case 14: CS2_HI = PIN14HI; break;
    case 16: CS2_HI = PIN16HI; break;
    case 17: CS2_HI = PIN17HI; break;
  }

  switch (cs2)
  {
    case 1:  CS2_LO = PIN1LO; break;
    case 14: CS2_LO = PIN14LO; break;
    case 16: CS2_LO = PIN16LO; break;
    case 17: CS2_LO = PIN17LO; break;
  }

  switch (rs)
  {
    case 1:  RS_HI = PIN1HI; break;
    case 14: RS_HI = PIN14HI; break;
    case 16: RS_HI = PIN16HI; break;
    case 17: RS_HI = PIN17HI; break;
  }

  switch (rs)
  {
    case 1:  RS_LO = PIN1LO; break;
    case 14: RS_LO = PIN14LO; break;
    case 16: RS_LO = PIN16LO; break;
    case 17: RS_LO = PIN17LO; break;
  }

  CS1 = CS1_HI | CS2_LO;
  CS2 = CS1_LO | CS2_HI;
}


void Delay(long microseconds)
{
  // from Yarvieh

  LARGE_INTEGER liFreq;
  LARGE_INTEGER liCnt;
  LARGE_INTEGER liStart;
  LONGLONG ticksPerMilliSec = 0;

  if ( QueryPerformanceFrequency(&liFreq) )
  {
    ticksPerMilliSec = (liFreq.QuadPart)/1000000;
  }
  else
  {
  // MessageBox(NULL,"Error obtaining frequency\n",0,NULL);
  }

  if ( QueryPerformanceCounter(&liStart) )
  {
    do
    {
      QueryPerformanceCounter(&liCnt);
    }while ((liStart.QuadPart + (__int64)(ticksPerMilliSec * microseconds)) > liCnt.QuadPart);
  }
}

void WriteCommand(unsigned char Command, unsigned char CS)
{
  Delay(delay);

  SetPortVal(CONTROL, ENABLE_LO | CS | RS_LO, 1);
  SetPortVal(DATA, Command, 1);
  SetPortVal(CONTROL, ENABLE_HI | CS | RS_LO, 1);
  Delay(delay);
  SetPortVal(CONTROL, ENABLE_LO | CS | RS_LO, 1);

  //SetPortVal(DATA, 0, 1);
}

void WriteData(const unsigned char Data[], unsigned int amount)
{
 unsigned char cs;
 unsigned int counter;
 for (counter=0; counter < amount;counter++)
 {
    cs = CurrentColumn>63?CS2:CS1;

    Delay(delay);
    SetPortVal(CONTROL, ENABLE_LO | cs | RS_HI, 1);
    SetPortVal(DATA, Data[counter], 1);
    SetPortVal(CONTROL, ENABLE_HI | cs | RS_HI, 1);
    Delay(delay);
    SetPortVal(CONTROL, ENABLE_LO | cs | RS_HI, 1);

    CurrentColumn++;
    if (CurrentColumn > 127)
    	return;
 }
}

void SetColumn(unsigned char y)
{
  CurrentColumn = y;
  if (y < 64)
  {
     WriteCommand(DISPLAY_COLUMN_SET | (y&63), CS1);
     WriteCommand(DISPLAY_COLUMN_SET | 0, CS2);
  } else
  {
     WriteCommand(DISPLAY_COLUMN_SET | 63, CS1);
     WriteCommand(DISPLAY_COLUMN_SET | ((y-64)&63), CS2);
  }
}

void SetPage(unsigned char x)
{
  Delay(delay);
  WriteCommand(DISPLAY_PAGE_SET | x, CS1);
  WriteCommand(DISPLAY_PAGE_SET | x, CS2);
}

void SetStartLine(unsigned char line)
{
  WriteCommand(DISPLAY_STARTLINE | (line & 63), CS1);
  WriteCommand(DISPLAY_STARTLINE | (line & 63), CS2);
}

void ClearLCD()
{
  unsigned char value;
  int x, a;
  value = 0x0;

  //SendLCDCommand(DISPLAY_ON, LCD_CS1);
  //SendLCDCommand(DISPLAY_ON, LCD_CS2);
  SetStartLine(0);

  for (x=0;x < 8;x++)
    {
      SetPage(x);SetColumn(0);
      for (a = 0 ;a < 128; a++)
      WriteData(&value, 1);
    }
}

void InitLCD()
{
  unsigned char value;
  int x, a;
  value = 0x0;

  WriteCommand(DISPLAY_ON, CS1);
  WriteCommand(DISPLAY_ON, CS2);
  SetStartLine(0);

  for (x=0;x < 8;x++)
    {
      SetPage(x);SetColumn(0);
      for (a = 0 ;a < 128; a++)
      WriteData(&value, 1);
    }
}



void main(int argc, char *argv[])
{
  
#ifdef WINIO
	InitializeWinIo();
#endif

	
  SetPins();

  InitLCD();
  ClearLCD();


if (!(argc>1))
{
	cout << "Syntax: blinken <file> Example: blinken ani.blm" << endl ;
	return;
}

std::string buffer;

unsigned char data = 254;

if(std::ifstream anifile (argv[1]))
{
  while(!anifile.eof())
  {
	while(!(buffer[0]=='@' || anifile.eof()))
		std::getline(anifile, buffer);

	if(anifile.eof())
    {
		anifile.close();
		return;
	}

	buffer.erase(0,1);
	int wait = atoi(buffer.c_str());
	ClearLCD();

	for(int i=0;i<8;i++)
	{
		std::getline(anifile, buffer);
	
		SetPage(i);
		int xpos=0;
		SetColumn(xpos);
		for(int j=0;j<18;j++)
		{
			SetColumn(xpos);
			if(buffer[j]=='0')
			{}
			else {
				for(int k=0;k<6;k++)
				    WriteData(&data,1);
			}
			xpos += 7;
		}
	}
	Sleep(wait);
  }
  anifile.close();
}

else
	cout << "Can't find file" << endl;



#ifdef WINIO
  ShutdownWinIo();
#endif

}
